behavior = {
    pathfind = function(self, dt)
        --Check to see if blocked in place and if so set a timeout
        if self.waittime <= 0 and self.moving == "" and
                blocked(self.x-1, self.y) and blocked(self.x, self.y-1) and
                blocked(self.x+1, self.y) and blocked(self.x, self.y+1) then
            self:wait(1)
        end

        if self.doing == "wait" then
            self.waittime = self.waittime - dt
            if self.waittime <= 0 then
                self.waittime = 0
                self.doing = "thinking"
            end
        elseif self.doing == "thinking" then
            self.co = coroutine.create(
                function()
                    self.tx, self.ty = math.random(1, 19), math.random(1,11)
                    local p = PathFinder.getPath( self, self.tx, self.ty, game.map )
                end
            )
            coroutine.resume(self.co)
        elseif self.doing == "pursue" then
            if self.pathstr ~= "" then
                if self.moving == "" then
                    if self.path[self.pathcur] == "U" then
                        self:up()
                    elseif self.path[self.pathcur] == "D" then
                        self:down()
                    elseif self.path[self.pathcur] == "R" then
                        self:right()
                    elseif self.path[self.pathcur] == "L" then
                        self:left()
                    end
                end
            else
                self:wait(1)
            end

            if self.ox < 0 then
                self.ox = self.ox + self.speed * dt
                if self.ox >= 0 then self:stop() end
            elseif self.ox > 0 then
                self.ox = self.ox - self.speed * dt
                if self.ox <= 0 then self:stop() end
            end
            if self.oy < 0 then
                self.oy = self.oy + self.speed * dt
                if self.oy >= 0 then self:stop() end
            elseif self.oy > 0 then
                self.oy = self.oy - self.speed * dt
                if self.oy <= 0 then self:stop() end
            end
        end

        if self.co then
            self.costat = coroutine.status(self.co)
        end
    end
}