itemImg = love.graphics.newImage("images/items.png")
itemQuad = {}

itemType = {}

function itemType:create(...)
    local instance = {}
    setmetatable(instance, {__index = self})
    instance:init(...)
    return instance
end
function itemType:init(x, y, id, v)
    v = v or {}
    self.x = x
    self.y = y
    self.id = id
    self.uuid = createUUID()

    self.collected = false
    self.gone = false

    self.framecount = 8
    self.anim = v.anim or math.random(0, self.framecount-1)
    self.animspeed = 12
    self.frame = 1

    self.bounce = 0
    self.bouncetimer = math.random(1,5)

    self.points = 100
end

function itemType:update(dt)
    if self.collected == false then
        self.bouncetimer = self.bouncetimer - dt
        if self.bouncetimer <= 0 then
            self.bounce = 0
            self.bouncetimer = 0
        end

        self.anim = (self.anim + dt * self.animspeed) % self.framecount
        self.frame = math.floor(self.anim)
    elseif self.gone == false then
        self.anim = self.anim + dt * self.animspeed
        if self.anim > self.framecount then
            self.anim = 0
            self.gone = true
        end
        self.frame = math.floor(self.anim)
    end
end

function itemType:draw()
    local x = (self.x + .5) * screen.tilesize
    local y = (self.y + .5) * screen.tilesize

    if self.collected == false then
        --love.graphics.setColor(255,255,255)
        --love.graphics.drawq(game.itemimg, game.itemquad[0][self.frame], x, y, 0, 1, 1, 8, 8)

        drawpool[#drawpool+1] = {
            type = "image", x = x, y = y,
            i = game.itemimg, q = game.itemquad[0][self.frame],
            ox = 8, oy = 16, who = "coin"
        }
        --drawpool[#drawpool+1] = { type = "line", x = x-2, y = y+1, x2 = x+2, y2 = y+1, c = {0,0,0,50} }
        --love.graphics.setColor(255,255,255)
        --love.graphics.setFont(font["tiny"])
        --love.graphics.print(tostring(self.frame), x+1, y+1)
    elseif self.gone == false then
        --love.graphics.setColor(255,255,255)
        --love.graphics.drawq(game.itemimg, game.itemquad[1][self.frame], x, y, 0, 1, 1, 8, 8)

        drawpool[#drawpool+1] = { type = "image", x = x, y = y - self.frame, i = game.itemimg, q = game.itemquad[1][self.frame], ox = 8, oy = 16 }
        --love.graphics.setColor(255,255,255)
        --love.graphics.setFont(font["tiny"])
        --love.graphics.print(tostring(self.frame), x+1, y+1)
    end
end

function itemType:collect(pid)
    if self.collected == false then
        self.collected = true
        self.anim = 1

        player[pid].itemscollected = player[pid].itemscollected + 1
        player[pid].score = player[pid].score + self.points
    end
end
