math.randomseed(os.time()) math.random() math.random() math.random()

require 'settings'
require 'scripts'
require 'game'
require 'gui'
require 'behavior'
require 'player'
require 'npc'
require 'enemy'
require 'settings'
require 'scripts'
require 'game'
require 'gui'
require 'behavior'
require 'player'
require 'npc'
require 'enemy'
require 'item'
require 'screen'
require 'pathfinder'
require 'fonts'
require 'editor'
require 'menu'
-- require 'shaders.init'
ease = require 'easing'

function love.load()
    debugger = {
        enemytext = ""
    }

    love.graphics.setLineStyle("rough")
    love.keyboard.setKeyRepeat(0.5, 0.05)

    screen = display:create(320,200)
    screen:addCanvas("main", screen.w+screen.tilesize, screen.h+screen.tilesize+screen.tilesize/2)
    screen:addCanvas("pan", screen.w+screen.tilesize, screen.h+screen.tilesize+screen.tilesize/2)
    screen:addCanvas("pan2", screen.w+screen.tilesize, screen.h+screen.tilesize+screen.tilesize/2)
    screen:addCanvas("overview", screen.w*screen.scale, screen.h*screen.scale)
    screen:addCanvas("menu", screen.w*screen.scale, screen.h*screen.scale)

    game = {
        state = "title",
        menu = {},
        menuOpen = true,
        paused = false,
        actor = {},
        map = {},
        tiles = love.graphics.newImage("images/tiles.png"),
        thit = {0,1,1,1,0,0,1,0},
        tilequad = {},
        titleback = love.graphics.newImage("images/back.png"),
        itemimg = love.graphics.newImage("images/items.png"),
        itemquad = {},
        playerimg = love.graphics.newImage("images/player.png"),
        playerquad = {},
        npcimg = love.graphics.newImage("images/npc.png"),
        npcquad = {},
        enemyimg = love.graphics.newImage("images/enemy.png"),
        enemyquad = {},
    }
    game.tiles:setFilter("nearest", "nearest")

    createTiles()
    createItems()
    createActors()

    --shaders:init(2)
    -- shaders:set(1, "scanline-3x")
    -- shaders:set(2, "seperator")

    menuLoad()
    newGame()
end

function love.update(dt)
    dt = math.min(dt, 1/15)

    if game.state == "game" then
        mx, my = math.floor(love.mouse.getX() / screen.scale) + (screen.tilesize / 2), math.floor(love.mouse.getY() / screen.scale)

        if game.paused == false then
            scriptUpdate(dt)

            local shouldUpdate = true
            if script.running == true then
                if script.line <= #script.run then
                    if script.run[script.line].pauseinput == true then
                        shouldUpdate = false
                    end
                end
            end

            if screen.panning == "" then
                for _, a in pairs(game.actor) do
                    a:update(dt)
                end

                for _, i in pairs(item) do
                    i:update(dt)
                end

                if shouldUpdate then
                    for _, e in pairs(enemy) do
                        e:update(dt)
                    end

                    for _, n in pairs(npc) do
                        n:update(dt)
                    end

                    for _, p in pairs(player) do
                        p:update(dt)
                    end
                end
            else
                screen:update(dt)
            end
        else
            menuUpdate(dt)
        end

        editor_update(dt)
    elseif game.state == "title" then
        menuUpdate(dt)
    end
end

function love.draw()
    if game.state == "game" then
        drawComposite()
        love.graphics.setCanvas(screen.canvas["overview"])
        screen.canvas["overview"]:clear(155,0,0,0)

        screen:draw()

        editor_draw()

        love.graphics.setCanvas()

        if game.paused == true then
            love.graphics.setCanvas(screen.canvas["menu"])
            screen.canvas["menu"]:clear(0,0,0,100)

            menuDraw()

            love.graphics.setCanvas()

            love.graphics.setCanvas(screen.canvas["overview"])

            love.graphics.setColor(0,0,0,100)
            love.graphics.draw(screen.canvas["menu"], 1*screen.scale, 1*screen.scale, 0, screen.scale, screen.scale)
            love.graphics.setColor(255,255,255)
            love.graphics.draw(screen.canvas["menu"], 0, 0, 0, screen.scale, screen.scale)

            love.graphics.setCanvas()
        end


        -- shaders:predraw()
        love.graphics.setColor(255,255,255)
        love.graphics.draw(screen.canvas["overview"], 0, 0)
        -- shaders:postdraw()

        love.graphics.setFont(font["dialog"])
        local t = ""
        t = t .. "FPS:    " .. love.timer.getFPS() .. "\n"
        t = t .. "Mouse:  " .. mx .. ", " .. my .. "\n"
        t = t .. "Player: " .. player[1].x .. ", " .. player[1].y .. "\n"
        t = t .. "Map:    " .. player[1].mapx .. ", " .. player[1].mapy .. "\n"
        --t = t .. screen.px .. ", " .. screen.py .. "\n"
        --t = t .. screen.panning .. "\n"
        t = t .. "Score:  " .. player[1].score .. " - " .. player[1].itemscollected .. "\n"

        local pt = ""
        for i, p in pairs(preferences) do
            if i == "keys" then
                pt = pt .. "Keys:\n"
                for i, p in pairs(preferences.keys) do
                    pt = pt .. "  " .. i .. " = " .. tostring(p) .. "\n"
                end
            else
                pt = pt .. i .. " = " .. tostring(p) .. "\n"
            end
        end
        t = t .. "\nPreferences:\n" .. pt .. "\n"

        local pt = ""
        for i, p in pairs(script) do
            if i == "run" then
                pt = pt .. "Run:\n"
                for i, p in pairs(script.run) do
                    pt = pt .. "  " .. i .. " = " .. tostring(p.text) .. "\n"
                end
            else
                pt = pt .. i .. " = " .. tostring(p) .. "\n"
            end
        end
        t = t .. "\nScript:\n" .. pt .. "\n"

        t = t .. "\nEnemy:\n" .. debugger.enemytext

        love.graphics.setColor(0,0,0)
        love.graphics.print(t, 11, 11)
        love.graphics.setColor(255,255,255)
        love.graphics.print(t, 10, 10)
    elseif game.state == "title" then
        love.graphics.setBackgroundColor(40,30,50)
        love.graphics.setCanvas(screen.canvas["menu"])
        screen.canvas["menu"]:clear(0,0,0,0)

        love.graphics.draw(game.titleback, 0, 0)

        menuDraw()

        love.graphics.setCanvas()

        -- shaders:predraw()
        love.graphics.setColor(0,0,0,200)
        love.graphics.draw(screen.canvas["menu"], 1*screen.scale, 1*screen.scale, 0, screen.scale, screen.scale)
        love.graphics.setColor(255,255,255)
        love.graphics.draw(screen.canvas["menu"], 0, 0, 0, screen.scale, screen.scale)
        -- shaders:postdraw()
    end
end

function love.keypressed(k, uni)
    if game.state == "game" then
        if k == "t" then
            scriptOpen("sample")
        end

        if script.running and script.run[script.line].haskeys then
            script.run[script.line]:keypressed(k, uni)
        end

        if k == "e" then
            editor.active = not editor.active
        end

        if k == "p" or k == "escape" then
            if game.paused == false then
                game.paused = true
                menuLoad()
                menuChangePage("main")
            end
        end

        editor_keypressed(k)

        if game.paused == true then
            menuKeypressed(k, uni)
        end
    elseif game.state == "title" then
        menuKeypressed(k, uni)
    end
end

function love.mousepressed(x, y, b)
    editor_mousepressed(x, y, b)
end

function love.focus(f)
    if f == false and game.paused == false and preferences.pauseinback == true then
        game.paused = true
        menuChangePage("main")
    end
end

