function menuLoad()
    game.menu = {
        curPage = "main",
        prevPage = "main",
        fade = 0,
        padx = 30, pady = 26,
        x = 0, y = 0, spacing = 14, pin = "bottomleft", font = "dialog",
        page = {}
    }

    menuAddPage("menu", "main", "")
    menuAddPageItem("menu", "main", "Continue", {
        action = function()
            if game.state == "game" then game.paused = false else loadGame() end
        end
    })
    menuAddPageItem("menu", "main", "New Game", {
        action = function()
            if game.state == "game" then menuChangePage("new") else newGame() end
        end
    })
    menuAddPageItem("menu", "main", "Editor", { action = function() end })
    menuAddPageItem("menu", "main", "Options", { action = function() menuChangePage("options") end })
    menuAddPageItem("menu", "main", "Quit", { action = function() menuChangePage("quit") end })

    menuAddPage("menu", "options", "main", "OPTIONS")
    menuAddPageItem("menu", "options", "Name", {
        value = "", maxlength = 20, caret = 0, type = "textinput",
        init = function(self) self.value = preferences.playername end, action = function(self) preferences.playername = self.value end,
        keypressed = function(self, k) guiHandleTextInput(self, k) end,
        draw = function(self, x, y) guiDrawTextInput(self, x, y, self.value) end
    })
    menuAddPageItem("menu", "options", "Sound FX", {
        value = 0, lowerlimit = 0, upperlimit = 100, increment = 5, type = "slider", style = "classic",
        init = function(self) self.value = preferences.sfxvolume end, action = function(self) preferences.sfxvolume = self.value end,
        keypressed = function(self, k) guiSliderHandleInput(self, k) end,
        draw = function(self, x, y) guiDrawSlider(self, x, y, self.lowerlimit, self.upperlimit, self.value) end
    })
    menuAddPageItem("menu", "options", "Music", {
        value = 0, lowerlimit = 0, upperlimit = 100, increment = 5, type = "slider", style = "classic",
        init = function(self) self.value = preferences.musicvolume end, action = function(self) preferences.musicvolume = self.value end,
        keypressed = function(self, k) guiSliderHandleInput(self, k) end,
        draw = function(self, x, y) guiDrawSlider(self, x, y, self.lowerlimit, self.upperlimit, self.value) end
    })
    menuAddPageItem("menu", "options", "Disabled Option", {
        checked = true, type = "checkbox", enabled = false,
        init = function(self) self.enabled = false end,
        keypressed = function(self, k) guiCheckboxHandleInput(self, k) end,
        draw = function(self, x, y) guiDrawCheckbox(self, x, y, self.lowerlimit, self.upperlimit, self.value) end
    })
    menuAddPageItem("menu", "options", "Pause in Background", {
        checked = true, type = "checkbox",
        init = function(self) self.checked = preferences.pauseinback end,
        action = function(self) preferences.pauseinback = self.checked end,
        keypressed = function(self, k) guiCheckboxHandleInput(self, k) end,
        draw = function(self, x, y) guiDrawCheckbox(self, x, y, self.lowerlimit, self.upperlimit, self.value) end
    })
    menuAddPageItem("menu", "options", "Customize Keys", {
        action = function() menuChangePage("keys") end
    })
    menuAddPageItem("menu", "options", "Allow Mouse Control", {
        checked = false, type = "checkbox",
        init = function(self) self.checked = preferences.allowmouse end,
        action = function(self) preferences.allowmouse = self.checked end,
        keypressed = function(self, k) guiCheckboxHandleInput(self, k) end,
        draw = function(self, x, y) guiDrawCheckbox(self, x, y, self.lowerlimit, self.upperlimit, self.value) end
    })

    menuAddPage("menu", "keys", "options", "CUSTOMIZE CONTROLS")
    menuAddPageItem("menu", "keys", "Left", {
        value = "left", type = "keycapture",
        init = function(self) self.value = preferences.keys.left end,
        action = function(self) preferences.keys.left = self.value end,
        keypressed = function(self, k) guiHandleKeyCapture(self, k) end,
        draw = function(self, x, y) guiDrawKeyCapture(self, x, y, self.value) end
    })
    menuAddPageItem("menu", "keys", "Right", {
        value = "right", type = "keycapture",
        init = function(self) self.value = preferences.keys.right end,
        action = function(self) preferences.keys.right = self.value end,
        keypressed = function(self, k) guiHandleKeyCapture(self, k) end,
        draw = function(self, x, y) guiDrawKeyCapture(self, x, y, self.value) end
    })
    menuAddPageItem("menu", "keys", "Up", {
        value = "up", type = "keycapture",
        init = function(self) self.value = preferences.keys.up end,
        action = function(self) preferences.keys.up = self.value end,
        keypressed = function(self, k) guiHandleKeyCapture(self, k) end,
        draw = function(self, x, y) guiDrawKeyCapture(self, x, y, self.value) end
    })
    menuAddPageItem("menu", "keys", "Down", {
        value = "down", type = "keycapture",
        init = function(self) self.value = preferences.keys.down end,
        action = function(self) preferences.keys.down = self.value end,
        keypressed = function(self, k) guiHandleKeyCapture(self, k) end,
        draw = function(self, x, y) guiDrawKeyCapture(self, x, y, self.value) end
    })
    menuAddPageItem("menu", "keys", "Attack/Action", {
        value = " ", type = "keycapture",
        init = function(self) self.value = preferences.keys.action end,
        action = function(self) preferences.keys.action = self.value end,
        keypressed = function(self, k) guiHandleKeyCapture(self, k) end,
        draw = function(self, x, y) guiDrawKeyCapture(self, x, y, self.value) end
    })

    menuAddPage("menu", "quit", "main", "ARE YOU SURE YOU WANT TO QUIT?")
    menuAddPageItem("menu", "quit", "Continue", { action = function() menuChangePage("main") end })
    menuAddPageItem("menu", "quit", "Quit", { action = function() love.event.push('quit') end })

    menuAddPage("menu", "new", "main", "THIS WILL END YOUR CURRENT GAME!")
    menuAddPageItem("menu", "new", "Cancel", { action = function() game.paused = false end })
    menuAddPageItem("menu", "new", "Start New Game", { action = function() newGame() end })

    menuChangePage("main")
end

function menuAddPage(menu, name, parent, title, selection, spacer)
    title = title or ""
    selection = selection or 1
    spacer = spacer or 120
    game[menu].page[name] = { selection = selection, title = title, spacer = spacer, parent = parent }
end

function menuAddPageItem(menu, page, name, options)
    local id = #game[menu].page[page] + 1
    if options.enabled == nil then options.enabled = true end
    if options.mode == nil then options.mode = "" end
    game[menu].page[page][id] = options
    game[menu].page[page][id].title = name
    game[menu].page[page][id].wobble = 0
end

function menuUpdate(dt)
    game.menu.fade = (game.menu.fade + dt * 100) % 255
    for o = 1, #game.menu.page[game.menu.curPage] do
        if game.menu.page[game.menu.curPage][o].wobble > 0 then
            game.menu.page[game.menu.curPage][o].wobble = game.menu.page[game.menu.curPage][o].wobble - dt * 10
            if game.menu.page[game.menu.curPage][o].wobble < 0 then game.menu.page[game.menu.curPage][o].wobble = 0 end
        end
    end
end

function menuDraw()
    local gmp = game.menu.page[game.menu.curPage]
    local j = 0
    for o = 1, #game.menu.page[game.menu.curPage] do
        j = j + 1
        local ofs = (j-1)
        if gmp.title ~= nil and gmp.title ~= "" then
            ofs = j
        end
        local x, y = game.menu.x, game.menu.y + (ofs * game.menu.spacing)
        if j == gmp.selection then
            gmp[j].selected = true
            --love.graphics.setColor(HSL(math.floor(game.menu.fade), 100,100,200))
            --love.graphics.rectangle("fill", -1, y-2, screen.w*screen.tilesize+2, 12)
            love.graphics.setFont(font["mono8"])
            love.graphics.setColor(HSL(math.floor(game.menu.fade), 255/2,255/2,255))
            love.graphics.print(">", x - 10, y)
        else
            gmp[j].selected = false
        end
        love.graphics.setFont(font[game.menu.font])
        love.graphics.setColor(255,255,255)
        if gmp[j].enabled == false then
            love.graphics.setColor(255,255,255,100)
        end
        local s = math.sin(gmp[j].wobble)
        local d = 5
        if s > 0 then d = 3 end
        local w = s * d
        love.graphics.print(gmp[j].title, x - w, y)

        if gmp[j].draw ~= nil then
            gmp[j].draw(gmp[j], x + gmp.spacer, y-1)
        end
    end
    if gmp.title then
        love.graphics.setColor(255,255,255)
        love.graphics.print(gmp.title, game.menu.x, game.menu.y)
    end
end

function menuChangePage(p)
    --game.menu.fade = 0
    if p ~= "" then
        local gmp = game.menu.page[p]

        for i = 1, #game.menu.page[p] do
            if game.menu.page[p][i].init then
                game.menu.page[p][i].init(game.menu.page[p][i])
            end
        end

        game.menu.prevPage = game.menu.curPage
        game.menu.curPage = p
        game.menu.x = game.menu.padx
        if game.menu.pin == "bottomleft" then
            game.menu.y = (love.graphics.getHeight() / screen.scale) - (game.menu.pady + (#game.menu.page[p] * game.menu.spacing))
            if game.menu.page[p].title == "" then game.menu.y = game.menu.y + game.menu.spacing end
        else
            game.menu.y = game.menu.pady
        end
        gmp[gmp.selection].wobble = math.pi * 2

        print(game.menu.y, #game.menu.page[p] * game.menu.spacing)
        print("Menu page loaded:", game.menu.curPage, "Previous:", game.menu.prevPage)
    end
end

function menuUnload()
    game.menu = {}
end

function menuKeypressed(k, uni)
    local gmp = game.menu.page[game.menu.curPage]
    if gmp[gmp.selection].type == "keycapture" and gmp[gmp.selection].mode == "waitforinput" then
        if k == "escape" then
            gmp[gmp.selection].mode = ""
        else
            gmp[gmp.selection].value = k
            gmp[gmp.selection].mode = ""
        end
        if gmp[gmp.selection].action then
            gmp[gmp.selection].action(gmp[gmp.selection])
        end
    else
        if gmp[gmp.selection].keypressed ~= nil and gmp[gmp.selection].enabled then
            gmp[gmp.selection].keypressed(gmp[gmp.selection], k)
        end

        if k == " " or k == "return" or k == "enter" then
            if gmp[gmp.selection].type == "keycapture" then
                gmp[gmp.selection].mode = "waitforinput"
            elseif gmp[gmp.selection].action and gmp[gmp.selection].enabled then
                gmp[gmp.selection].action(gmp[gmp.selection])
            end
        end

        if k == "up" then
            --game.menu.fade = 0
            gmp.selection = gmp.selection - 1
            if gmp.selection < 1 then gmp.selection = #gmp end
            if gmp[gmp.selection].enabled then
                gmp[gmp.selection].wobble = math.pi * 2
            end
        elseif k == "down" then
            --game.menu.fade = 0
            gmp.selection = gmp.selection + 1
            if gmp.selection > #gmp then gmp.selection = 1 end
            if gmp[gmp.selection].enabled then
                gmp[gmp.selection].wobble = math.pi * 2
            end
        end

        if k == "escape" then
            menuChangePage(game.menu.page[game.menu.curPage].parent)
        end
    end
end

function guiDrawSlider(self, x, y, l, u, v, w)
    w = w or 50
    bw = (u - l)
    bn = (w / bw) * v
    if self.style == "classic" then
        love.graphics.rectangle("line", x, y+4, w + 3, 1)
        love.graphics.rectangle("fill", x+bn-1, y, 4, 10)
    else
        love.graphics.rectangle("line", x, y, w + 3, 9)
        love.graphics.rectangle("fill", x+1, y+2, bn, 6)
    end
end

function guiSliderHandleInput(self, k)
    if k == "left" then
        self.value = self.value - self.increment
        if self.value < self.lowerlimit then self.value = self.lowerlimit end
        if self.action then
            self.action(self)
        end
    elseif k == "right" then
        self.value = self.value + self.increment
        if self.value > self.upperlimit then self.value = self.upperlimit end
        if self.action then
            self.action(self)
        end
    end
end

function guiDrawCheckbox(self, x, y)
    if self.checked then
        love.graphics.rectangle("line", x, y, 9, 9)
        love.graphics.line(x, y+1, x+8, y+9)
        love.graphics.line(x+8, y+1, x, y+9)
    else
        love.graphics.rectangle("line", x, y, 9, 9)
    end
end

function guiCheckboxHandleInput(self, k)
    if k == " " or k == "enter" or k == "return" then
        self.checked = not self.checked
    end
end


function guiHandleTextInput(self, k)
    if isChar(k) then
        if #self.value < self.maxlength then
            local char = k
            if shiftHeld() then char = string.upper(char) end
            self.value = self.value .. char
        end
    elseif k == "backspace" then
        self.value = string.sub(self.value, 0, #self.value - 1)
    elseif k == "left" then

    elseif k == "right" then

    end
end

function guiDrawTextInput(self, x, y, txt)
    local caret = "|"
    if math.cos(love.timer.getTime() * 10) >= 0 or self.selected == false then caret = "" end
    love.graphics.setColor(255,255,255)
    love.graphics.print(txt .. caret, x, y+1)
end


function guiHandleKeyCapture(self, k)

end

function guiDrawKeyCapture(self, x, y, txt)
    local chars = { [" "] = "SPACE", ["lshift"] = "Left Shift", ["rshift"] = "Right Shift" }
    local txt2 = (chars[txt] or txt)
    if self.mode == "waitforinput" then txt2 = "??" end
    love.graphics.print(string.upper(txt2), x, y+1)
end


function isChar(k, chars)
    local ic = false
    chars = chars or "0123456789abcdefghijklmnopqrstuvwxyz "
    for i = 1, #chars do
        if string.sub(chars, i, i) == k then
            ic = true
        end
    end
    return ic
end